package com.zanxiang.game.data.serve.controller;

import com.zanxiang.erp.security.annotation.PreAuthorize;
import com.zanxiang.game.data.serve.pojo.dto.AgentDayAgainDTO;
import com.zanxiang.game.data.serve.pojo.dto.GamePromoteDayDTO;
import com.zanxiang.game.data.serve.pojo.dto.GamePromoteDayTotalDTO;
import com.zanxiang.game.data.serve.pojo.dto.GamePromoteTotalDTO;
import com.zanxiang.game.data.serve.pojo.vo.AgentDayAgainVO;
import com.zanxiang.game.data.serve.pojo.vo.GamePromoteDayTotalVO;
import com.zanxiang.game.data.serve.pojo.vo.GamePromoteDayVO;
import com.zanxiang.game.data.serve.pojo.vo.GamePromoteTotalVO;
import com.zanxiang.game.data.serve.service.IAccountAgentDayService;
import com.zanxiang.game.data.serve.utils.Page;
import com.zanxiang.module.util.pojo.ResultVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.util.List;
import java.util.Map;

@Api(tags = "推广数据")
@RestController
@RequestMapping("/promote")
public class AccountAgentDayController {
    @Autowired
    private IAccountAgentDayService accountAgentDayService;

    @ApiOperation(value = "推广每日数据")
    @PreAuthorize(permissionKey = "gameData:promote:day")
    @PostMapping("/day")
    public ResultVO<Page<GamePromoteDayVO>> accountAgentDay(@RequestBody GamePromoteDayDTO dto) {
        return ResultVO.ok(accountAgentDayService.accountAgentDay(dto));
    }

    @ApiOperation(value = "推广每日数据总计")
    @PreAuthorize(permissionKey = "gameData:promote:dayTotal")
    @PostMapping("/day/total")
    public ResultVO<GamePromoteDayTotalVO> accountAgentDayTotal(@RequestBody GamePromoteDayTotalDTO dto) {
        return ResultVO.ok(accountAgentDayService.accountAgentDayTotal(dto));
    }

    @ApiOperation(value = "推广总数据")
    @PreAuthorize(permissionKey = "gameData:promote:total")
    @PostMapping("/total")
    public ResultVO<Page<GamePromoteTotalVO>> accountAgentTotal(@RequestBody GamePromoteTotalDTO dto) {
        return ResultVO.ok(accountAgentDayService.accountAgentTotal(dto));
    }

    @ApiOperation(value = "推广渠道每日复充数据")
    @PreAuthorize(permissionKey = "gameData:accountAgent:again")
    @PostMapping("/again")
    public ResultVO<Map<LocalDate, List<AgentDayAgainVO>>> accountAgentDayAgain(@RequestBody AgentDayAgainDTO dto) throws Exception {
        return ResultVO.ok(accountAgentDayService.accountAgentDayAgain(dto));
    }
}
